OGRE: Ogre::GLES2TextureManager Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
Ogre::GLES2TextureManager Class Reference

GL ES-specific implementation of a TextureManager. More...

`#include <OgreGLES2TextureManager.h>`

Inheritance diagram for Ogre::GLES2TextureManager:
[legend]

## Public Types
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap

## Public Member Functions
| GLES2TextureManager (GLES2Support &support)
virtual | ~GLES2TextureManager ()
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded. More...
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e. More...
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded. More...
TexturePtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new texture. More...
TexturePtr | createManual (const String &name, const String &group, TextureType texType, uint width, uint height, int numMipmaps, PixelFormat format, int usage=TU_DEFAULT, ManualResourceLoader *loader=0, bool hwGammaCorrection=false, uint fsaa=0, const String &fsaaHint=BLANKSTRING, bool explicitResolve=false, bool shareableDepthBuffer=true)
| Create a manual texture with a depth of 1 (not loaded from a file). More...
virtual TexturePtr | createManual (const String &name, const String &group, TextureType texType, uint width, uint height, uint depth, int numMipmaps, PixelFormat format, int usage=TU_DEFAULT, ManualResourceLoader *loader=0, bool hwGammaCorrection=false, uint fsaa=0, const String &fsaaHint=BLANKSTRING, bool explicitResolve=false, bool shareableDepthBuffer=true)
| Create a manual texture with specified width, height and depth (not loaded from a file). More...
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists. More...
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool isAlpha=false, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
| Create a new texture, or retrieve an existing one with the same name if it already exists. More...
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it. More...
void | destroyAllResourcePools ()
| destroy all pools More...
void | destroyResourcePool (const String &name)
| Destroy a resource pool. More...
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool. More...
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist. More...
TexturePtr | getByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Get a resource by name. More...
virtual size_t | getDefaultNumMipmaps ()
| Gets the default number of mipmaps to be used for loaded textures. More...
virtual Real | getLoadingOrder (void) const
| Gets the relative loading order of resources of this type. More...
virtual size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use. More...
virtual size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes. More...
PixelFormat | getNativeFormat (TextureType ttype, PixelFormat format, int usage)
| Gets the format which will be natively used for a requested format given the constraints of the current device. More...
virtual ushort | getPreferredFloatBitDepth (void) const
| Gets preferred bit depth for float pixel format textures. More...
virtual ushort | getPreferredIntegerBitDepth (void) const
| Gets preferred bit depth for integer pixel format textures. More...
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist. More...
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager. More...
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists. More...
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles. More...
virtual const StringVector & | getScriptPatterns (void) const
| Gets the file patterns which should be used to find scripts for this ResourceManager. More...
virtual bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output. More...
GLuint | getWarningTextureID ()
virtual bool | isEquivalentFormatSupported (TextureType ttype, PixelFormat format, int usage)
| Returns whether this render system can support the texture format requested with the given usage options, or another format with no quality reduction. More...
virtual bool | isFormatSupported (TextureType ttype, PixelFormat format, int usage)
| Returns whether this render system can natively support the precise texture format requested with the given usage options. More...
bool | isHardwareFilteringSupported (TextureType ttype, PixelFormat format, int usage, bool preciseFormatOnly=false)
| Returns whether this render system has hardware filtering supported for the texture format requested with the given usage options. More...
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters). More...
virtual TexturePtr | load (const String &name, const String &group, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool isAlpha=false, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
| Loads a texture from a file. More...
virtual TexturePtr | loadImage (const String &name, const String &group, const Image &img, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool isAlpha=false, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
| Loads a texture from an Image object. More...
virtual TexturePtr | loadRawData (const String &name, const String &group, DataStreamPtr &stream, ushort width, ushort height, PixelFormat format, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool hwGammaCorrection=false)
| Loads a texture from a raw data stream. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | parseScript (DataStreamPtr &stream, const String &groupName)
| Parse the definition of a set of resources from a script file. More...
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters). More...
virtual TexturePtr | prepare (const String &name, const String &group, TextureType texType=TEX_TYPE_2D, int numMipmaps=MIP_DEFAULT, Real gamma=1.0f, bool isAlpha=false, PixelFormat desiredFormat=PF_UNKNOWN, bool hwGammaCorrection=false)
| Prepares to loads a texture from a file. More...
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded. More...
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded. More...
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded. More...
virtual void | remove (const ResourcePtr &r)
| Remove a single resource. More...
virtual void | remove (const String &name)
| Remove a single resource by name. More...
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle. More...
virtual void | removeAll (void)
| Removes all resources. More...
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object. More...
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager. More...
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager. More...
virtual void | setDefaultNumMipmaps (size_t num)
| Sets the default number of mipmaps to be used for loaded textures, for when textures are loaded automatically (e.g. More...
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use. More...
virtual void | setPreferredBitDepths (ushort integerBits, ushort floatBits, bool reloadTextures=true)
| Sets preferred bit depth for integer and float pixel format. More...
virtual void | setPreferredFloatBitDepth (ushort bits, bool reloadTextures=true)
| Sets preferred bit depth for float pixel format textures. More...
virtual void | setPreferredIntegerBitDepth (ushort bits, bool reloadTextures=true)
| Sets preferred bit depth for integer pixel format textures. More...
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output. More...
virtual void | unload (const String &name)
| Unloads a single resource by name. More...
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle. More...
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources. More...
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources. More...
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object. More...

## Static Public Member Functions
static TextureManager & | getSingleton (void)
| Override standard Singleton retrieval. More...
static TextureManager * | getSingletonPtr (void)
| Override standard Singleton retrieval. More...

## Public Attributes
| OGRE_AUTO_MUTEX

## Friends
class | GLES2RenderSystem

## Detailed Description

GL ES-specific implementation of a TextureManager.

## Member Typedef Documentation

## ◆ ResourceCreateOrRetrieveResult

typedef std::pair<ResourcePtr, bool> Ogre::ResourceManager::ResourceCreateOrRetrieveResult
| inherited

## ◆ ResourceHandleMap

typedef map<ResourceHandle, ResourcePtr>::type Ogre::ResourceManager::ResourceHandleMap
| inherited

## ◆ ResourceMap

typedef unordered_map< String, ResourcePtr >::type Ogre::ResourceManager::ResourceMap
| inherited

## ◆ ResourceMapIterator

typedef MapIterator<ResourceHandleMap> Ogre::ResourceManager::ResourceMapIterator
| inherited

## ◆ ResourceWithGroupMap

typedef unordered_map< String, ResourceMap >::type Ogre::ResourceManager::ResourceWithGroupMap
| inherited

## Constructor & Destructor Documentation

## ◆ GLES2TextureManager()

Ogre::GLES2TextureManager::GLES2TextureManager | ( | GLES2Support & | support | ) |

## ◆ ~GLES2TextureManager()

virtual Ogre::GLES2TextureManager::~GLES2TextureManager | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _notifyResourceLoaded()

virtual void Ogre::ResourceManager::_notifyResourceLoaded | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been loaded.

## ◆ _notifyResourceTouched()

virtual void Ogre::ResourceManager::_notifyResourceTouched | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been 'touched', i.e.

used.

## ◆ _notifyResourceUnloaded()

virtual void Ogre::ResourceManager::_notifyResourceUnloaded | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been unloaded.

## ◆ create()

TexturePtr Ogre::TextureManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |
| inherited

Create a new texture.

See also
  ResourceManager::createResource

## ◆ createManual() [1/2]

TexturePtr Ogre::TextureManager::createManual | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType,
|  | uint | width,
|  | uint | height,
|  | int | numMipmaps,
|  | PixelFormat | format,
|  | int | usage = `TU_DEFAULT`,
|  | ManualResourceLoader * | loader = `0`,
|  | bool | hwGammaCorrection = `false`,
|  | uint | fsaa = `0`,
|  | const String & | fsaaHint = `BLANKSTRING`,
|  | bool | explicitResolve = `false`,
|  | bool | shareableDepthBuffer = `true`
| ) |  |
| inlineinherited

Create a manual texture with a depth of 1 (not loaded from a file).

Parameters

  name | The name to give the resulting texture
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  width | The width of the texture
  height | The height of the texture
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()). If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  format | The internal format you wish to request; the manager reserves the right to create a different format if the one you select is not available in this context.
  usage | The kind of usage this texture is intended for. It is a combination of TU_STATIC, TU_DYNAMIC, TU_WRITE_ONLY, TU_AUTOMIPMAP and TU_RENDERTARGET (see TextureUsage enum). You are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY.
  loader | If you intend the contents of the manual texture to be regularly updated, to the extent that you don't need to recover the contents if the texture content is lost somehow, you can leave this parameter as 0. However, if you intend to populate the texture only once, then you should implement ManualResourceLoader and pass a pointer to it in this parameter; this means that if the manual texture ever needs to be reloaded, the ManualResourceLoader will be called to do it.
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.
  fsaa | The level of multisampling to use if this is a render target. Ignored if usage does not include TU_RENDERTARGET or if the device does not support it.
  explicitResolve | Whether FSAA resolves are done implicitly when used as texture, or must be done explicitly. @See TextureDefinitionBase::TextureDefinition::fsaaExplicitResolve
  shareableDepthBuffer | Only valid for depth texture formats. When true, the depth buffer is a "view" of an existing depth texture (e.g. useful for reading the depth buffer contents of a GBuffer pass in deferred rendering). When false, the texture gets its own depth buffer created for itself (e.g. useful for shadow mapping, which is a depth-only pass)

## ◆ createManual() [2/2]

virtual TexturePtr Ogre::TextureManager::createManual | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType,
|  | uint | width,
|  | uint | height,
|  | uint | depth,
|  | int | numMipmaps,
|  | PixelFormat | format,
|  | int | usage = `TU_DEFAULT`,
|  | ManualResourceLoader * | loader = `0`,
|  | bool | hwGammaCorrection = `false`,
|  | uint | fsaa = `0`,
|  | const String & | fsaaHint = `BLANKSTRING`,
|  | bool | explicitResolve = `false`,
|  | bool | shareableDepthBuffer = `true`
| ) |  |
| virtualinherited

Create a manual texture with specified width, height and depth (not loaded from a file).

Parameters

  name | The name to give the resulting texture
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  width | The width of the texture
  height | The height of the texture
  depth | The depth of the texture
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  format | The internal format you wish to request; the manager reserves the right to create a different format if the one you select is not available in this context.
  usage | The kind of usage this texture is intended for. It is a combination of TU_STATIC, TU_DYNAMIC, TU_WRITE_ONLY, TU_AUTOMIPMAP and TU_RENDERTARGET (see TextureUsage enum). You are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY.
  loader | If you intend the contents of the manual texture to be regularly updated, to the extent that you don't need to recover the contents if the texture content is lost somehow, you can leave this parameter as 0. However, if you intend to populate the texture only once, then you should implement ManualResourceLoader and pass a pointer to it in this parameter; this means that if the manual texture ever needs to be reloaded, the ManualResourceLoader will be called to do it.
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.
  fsaa | The level of multisampling to use if this is a render target. Ignored if usage does not include TU_RENDERTARGET or if the device does not support it.
  explicitResolve | Whether FSAA resolves are done implicitly when used as texture, or must be done explicitly. @See TextureDefinitionBase::TextureDefinition::fsaaExplicitResolve
  shareableDepthBuffer | Only valid for depth texture formats. When true, the depth buffer is a "view" of an existing depth texture (e.g. useful for reading the depth buffer contents of a GBuffer pass in deferred rendering). When false, the texture gets its own depth buffer created for itself (e.g. useful for shadow mapping, which is a depth-only pass)

## ◆ createOrRetrieve() [1/2]

virtual ResourceCreateOrRetrieveResult Ogre::ResourceManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |
| virtualinherited

Create a new resource, or retrieve an existing one with the same name if it already exists.

Remarks
  This method performs the same task as calling getByName() followed by create() if that returns null. The advantage is that it does it in one call so there are no race conditions if using multiple threads that could cause getByName() to return null, but create() to fail because another thread created a resource in between.

See also
  ResourceManager::createResource
  ResourceManager::getResourceByName

Returns
  A pair, the first element being the pointer, and the second being an indicator specifying whether the resource was newly created.

## ◆ createOrRetrieve() [2/2]

virtual ResourceCreateOrRetrieveResult Ogre::TextureManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`,
|  | TextureType | texType = `TEX_TYPE_2D`,
|  | int | numMipmaps = `MIP_DEFAULT`,
|  | Real | gamma = `1.0f`,
|  | bool | isAlpha = `false`,
|  | PixelFormat | desiredFormat = `PF_UNKNOWN`,
|  | bool | hwGammaCorrection = `false`
| ) |  |
| virtualinherited

Create a new texture, or retrieve an existing one with the same name if it already exists.

Parameters

  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening)
  isAlpha | Only applicable to greyscale images. If true, specifies that the image should be loaded into an alpha texture rather than a single channel colour texture - useful for fixed-function systems.
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

See also
  ResourceManager::createOrRetrieve

## ◆ createResource()

virtual ResourcePtr Ogre::ResourceManager::createResource | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |
| virtualinherited

Creates a new blank resource, but does not immediately load it.

Remarks
  Resource managers handle disparate types of resources, so if you want to get at the detailed interface of this resource, you'll have to cast the result to the subclass you know you're creating.

Parameters

  name | The unique name of the resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

## ◆ destroyAllResourcePools()

void Ogre::ResourceManager::destroyAllResourcePools | ( |  | ) |
| inherited

destroy all pools

## ◆ destroyResourcePool() [1/2]

void Ogre::ResourceManager::destroyResourcePool | ( | const String & | name | ) |
| inherited

Destroy a resource pool.

## ◆ destroyResourcePool() [2/2]

void Ogre::ResourceManager::destroyResourcePool | ( | ResourcePool * | pool | ) |
| inherited

Destroy a resource pool.

## ◆ getByHandle()

virtual ResourcePtr Ogre::ResourceManager::getByHandle | ( | ResourceHandle | handle | ) |
| virtualinherited

Retrieves a pointer to a resource by handle, or null if the resource does not exist.

## ◆ getByName()

TexturePtr Ogre::TextureManager::getByName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |
| inherited

Get a resource by name.

See also
  ResourceManager::getResourceByName

## ◆ getDefaultNumMipmaps()

virtual size_t Ogre::TextureManager::getDefaultNumMipmaps | ( |  | ) |
| inlinevirtualinherited

Gets the default number of mipmaps to be used for loaded textures.

## ◆ getLoadingOrder()

virtual Real Ogre::ResourceManager::getLoadingOrder | ( | void |  | ) | const
| inlinevirtualinherited

Gets the relative loading order of resources of this type.

Remarks
  There are dependencies between some kinds of resource in terms of loading order, and this value enumerates that. Higher values load later during bulk loading tasks.

Implements Ogre::ScriptLoader.

## ◆ getMemoryBudget()

virtual size_t Ogre::ResourceManager::getMemoryBudget | ( | void |  | ) | const
| virtualinherited

Get the limit on the amount of memory this resource handler may use.

## ◆ getMemoryUsage()

virtual size_t Ogre::ResourceManager::getMemoryUsage | ( | void |  | ) | const
| inlinevirtualinherited

Gets the current memory usage, in bytes.

## ◆ getNativeFormat()

PixelFormat Ogre::GLES2TextureManager::getNativeFormat | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage
| ) |  |
| virtual

Gets the format which will be natively used for a requested format given the constraints of the current device.

Implements Ogre::TextureManager.

## ◆ getPreferredFloatBitDepth()

virtual ushort Ogre::TextureManager::getPreferredFloatBitDepth | ( | void |  | ) | const
| virtualinherited

Gets preferred bit depth for float pixel format textures.

## ◆ getPreferredIntegerBitDepth()

virtual ushort Ogre::TextureManager::getPreferredIntegerBitDepth | ( | void |  | ) | const
| virtualinherited

Gets preferred bit depth for integer pixel format textures.

## ◆ getResourceByName()

virtual ResourcePtr Ogre::ResourceManager::getResourceByName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |
| virtualinherited

Retrieves a pointer to a resource by name, or null if the resource does not exist.

## ◆ getResourceIterator()

ResourceMapIterator Ogre::ResourceManager::getResourceIterator | ( | void |  | ) |
| inlineinherited

Returns an iterator over all resources in this manager.

Note
  Use of this iterator is NOT thread safe!

## ◆ getResourcePool()

ResourcePool* Ogre::ResourceManager::getResourcePool | ( | const String & | name | ) |
| inherited

Create a resource pool, or reuse one that already exists.

## ◆ getResourceType()

const String& Ogre::ResourceManager::getResourceType | ( | void |  | ) | const
| inlineinherited

Gets a string identifying the type of resource this manager handles.

## ◆ getScriptPatterns()

virtual const StringVector& Ogre::ResourceManager::getScriptPatterns | ( | void |  | ) | const
| inlinevirtualinherited

Gets the file patterns which should be used to find scripts for this ResourceManager.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

  This method lets you determine the file pattern which will be used to identify scripts intended for this manager.

Returns
  A list of file patterns, in the order they should be searched in.

See also
  isScriptingSupported, parseScript

Implements Ogre::ScriptLoader.

## ◆ getSingleton()

static TextureManager& Ogre::TextureManager::getSingleton | ( | void |  | ) |
| staticinherited

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSingletonPtr()

static TextureManager* Ogre::TextureManager::getSingletonPtr | ( | void |  | ) |
| staticinherited

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getVerbose()

virtual bool Ogre::ResourceManager::getVerbose | ( | void |  | ) |
| inlinevirtualinherited

Gets whether this manager and its resources habitually produce log output.

## ◆ getWarningTextureID()

GLuint Ogre::GLES2TextureManager::getWarningTextureID | ( |  | ) |
| inline

## ◆ isEquivalentFormatSupported()

virtual bool Ogre::TextureManager::isEquivalentFormatSupported | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage
| ) |  |
| virtualinherited

Returns whether this render system can support the texture format requested with the given usage options, or another format with no quality reduction.

## ◆ isFormatSupported()

virtual bool Ogre::TextureManager::isFormatSupported | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage
| ) |  |
| virtualinherited

Returns whether this render system can natively support the precise texture format requested with the given usage options.

Remarks
  You can still create textures with this format even if this method returns false; the texture format will just be altered to one which the device does support.

Note
  Sometimes the device may just slightly change the format, such as reordering the channels or packing the channels differently, without it making and qualitative differences to the texture. If you want to just detect whether the quality of a given texture will be reduced, use isEquivalentFormatSupport instead.

Parameters

  format | The pixel format requested
  usage | The kind of usage this texture is intended for, a combination of the TextureUsage flags.

Returns
  true if the format is natively supported, false if a fallback would be used.

## ◆ isHardwareFilteringSupported()

bool Ogre::GLES2TextureManager::isHardwareFilteringSupported | ( | TextureType | ttype,
|  | PixelFormat | format,
|  | int | usage,
|  | bool | preciseFormatOnly = `false`
| ) |  |
| virtual

Returns whether this render system has hardware filtering supported for the texture format requested with the given usage options.

Remarks
  Not all texture format are supports filtering by the hardware, i.e. some cards support floating point format, but it doesn't supports filtering on the floating point texture at all, or only a subset floating point formats have flitering supported.

  In the case you want to write shader to work with floating point texture, and you want to produce better visual quality, it's necessary to flitering the texture manually in shader (potential requires four or more texture fetch instructions, plus several arithmetic instructions) if filtering doesn't supported by hardware. But in case on the hardware that supports floating point filtering natively, it had better to adopt this capability for performance (because only one texture fetch instruction are required) and doesn't loss visual quality.

  This method allow you queries hardware texture filtering capability to deciding which verion of the shader to be used. Note it's up to you to write multi-version shaders for support various hardware, internal engine can't do that for you automatically.

Note
  Under GL, texture filtering are always supported by driver, but if it's not supported by hardware natively, software simulation will be used, and you will end up with very slow speed (less than 0.1 fps for example). To slove this performance problem, you must disable filtering manually (by use filtering none in the material script's texture_unit section, or call TextureUnitState::setTextureFiltering with TFO_NONE if populate material in code).

Parameters

  ttype | The texture type requested
  format | The pixel format requested
  usage | The kind of usage this texture is intended for, a combination of the TextureUsage flags.
  preciseFormatOnly | Whether precise or fallback format mode is used to detecting. In case the pixel format doesn't supported by device, false will be returned if in precise mode, and natively used pixel format will be actually use to check if in fallback mode.

Returns
  true if the texture filtering is supported.

Implements Ogre::TextureManager.

## ◆ load() [1/2]

virtual ResourcePtr Ogre::ResourceManager::load | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | bool | backgroundThread = `false`
| ) |  |
| virtualinherited

Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ load() [2/2]

virtual TexturePtr Ogre::TextureManager::load | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType = `TEX_TYPE_2D`,
|  | int | numMipmaps = `MIP_DEFAULT`,
|  | Real | gamma = `1.0f`,
|  | bool | isAlpha = `false`,
|  | PixelFormat | desiredFormat = `PF_UNKNOWN`,
|  | bool | hwGammaCorrection = `false`
| ) |  |
| virtualinherited

Loads a texture from a file.

Parameters

  name | The file to load, or a String identifier in some cases
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening) during loading
  isAlpha | Only applicable to greyscale images. If true, specifies that the image should be loaded into an alpha texture rather than a single channel colour texture - useful for fixed-function systems.
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture. Pass PF_UNKNOWN to default.
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

## ◆ loadImage()

virtual TexturePtr Ogre::TextureManager::loadImage | ( | const String & | name,
|  | const String & | group,
|  | const Image & | img,
|  | TextureType | texType = `TEX_TYPE_2D`,
|  | int | numMipmaps = `MIP_DEFAULT`,
|  | Real | gamma = `1.0f`,
|  | bool | isAlpha = `false`,
|  | PixelFormat | desiredFormat = `PF_UNKNOWN`,
|  | bool | hwGammaCorrection = `false`
| ) |  |
| virtualinherited

Loads a texture from an Image object.

Note
  The texture will create as manual texture without loader.

Parameters

  name | The name to give the resulting texture
  group | The name of the resource group to assign the texture to
  img | The Image object which contains the data to load
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening)
  isAlpha | Only applicable to greyscale images. If true, specifies that the image should be loaded into an alpha texture rather than a single channel colour texture - useful for fixed-function systems.
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

## ◆ loadRawData()

virtual TexturePtr Ogre::TextureManager::loadRawData | ( | const String & | name,
|  | const String & | group,
|  | DataStreamPtr & | stream,
|  | ushort | width,
|  | ushort | height,
|  | PixelFormat | format,
|  | TextureType | texType = `TEX_TYPE_2D`,
|  | int | numMipmaps = `MIP_DEFAULT`,
|  | Real | gamma = `1.0f`,
|  | bool | hwGammaCorrection = `false`
| ) |  |
| virtualinherited

Loads a texture from a raw data stream.

Note
  The texture will create as manual texture without loader.

Parameters

  name | The name to give the resulting texture
  group | The name of the resource group to assign the texture to
  stream | Incoming data stream
  width | The width of the texture
  height | The height of the texture
  format | The format of the data being passed in; the manager reserves the right to create a different format for the texture if the original format is not available in this context.
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening) while loading
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ parseScript()

virtual void Ogre::ResourceManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName
| ) |  |
| inlinevirtualinherited

Parse the definition of a set of resources from a script file.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

Parameters

  stream | Weak reference to a data stream which is the source of the script
  groupName | The name of the resource group that resources which are parsed are to become a member of. If this group is loaded or unloaded, then the resources discovered in this script will be loaded / unloaded with it.

Implements Ogre::ScriptLoader.

Reimplemented in Ogre::MaterialManager, and Ogre::FontManager.

## ◆ prepare() [1/2]

virtual ResourcePtr Ogre::ResourceManager::prepare | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | bool | backgroundThread = `false`
| ) |  |
| virtualinherited

Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ prepare() [2/2]

virtual TexturePtr Ogre::TextureManager::prepare | ( | const String & | name,
|  | const String & | group,
|  | TextureType | texType = `TEX_TYPE_2D`,
|  | int | numMipmaps = `MIP_DEFAULT`,
|  | Real | gamma = `1.0f`,
|  | bool | isAlpha = `false`,
|  | PixelFormat | desiredFormat = `PF_UNKNOWN`,
|  | bool | hwGammaCorrection = `false`
| ) |  |
| virtualinherited

Prepares to loads a texture from a file.

Parameters

  name | The file to load, or a String identifier in some cases
  group | The name of the resource group to assign the texture to
  texType | The type of texture to load/create, defaults to normal 2D textures
  numMipmaps | The number of pre-filtered mipmaps to generate. If left to MIP_DEFAULT then the TextureManager's default number of mipmaps will be used (see setDefaultNumMipmaps()) If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.
  gamma | The gamma adjustment factor to apply to this texture (brightening/darkening)
  isAlpha | Only applicable to greyscale images. If true, specifies that the image should be loaded into an alpha texture rather than a single channel colour texture - useful for fixed-function systems.
  desiredFormat | The format you would like to have used instead of the format being based on the contents of the texture
  hwGammaCorrection | Pass 'true' to enable hardware gamma correction (sRGB) on this texture. The hardware will convert from gamma space to linear space when reading from this texture. Only applicable for 8-bits per channel textures, will be ignored for other types. Has the advantage over pre-applied gamma that the texture precision is maintained.

## ◆ reloadAll() [1/2]

void Ogre::ResourceManager::reloadAll | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  reloadableOnly | If true (the default), only reload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't loaded again. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, and Ogre::Resource::LF_INCLUDE_NON_RELOADABLE.

## ◆ reloadAll() [2/2]

virtual void Ogre::ResourceManager::reloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtualinherited

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources. Additionally, reloading could be done with preserving some selected resource states that could be used elsewhere.

See also
  Resource::LoadingFlags for additional information.

## ◆ reloadUnreferencedResources()

void Ogre::ResourceManager::reloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Caused all currently loaded but not referenced by any other object resources to be reloaded.

Remarks
  This method behaves like reloadAll, except that it only reloads resources which are not in use, i.e. not referenced by other objects.

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of reloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only reloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, and Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE.

## ◆ remove() [1/3]

virtual void Ogre::ResourceManager::remove | ( | const ResourcePtr & | r | ) |
| virtualinherited

Remove a single resource.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [2/3]

virtual void Ogre::ResourceManager::remove | ( | const String & | name | ) |
| virtualinherited

Remove a single resource by name.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [3/3]

virtual void Ogre::ResourceManager::remove | ( | ResourceHandle | handle | ) |
| virtualinherited

Remove a single resource by handle.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeAll()

virtual void Ogre::ResourceManager::removeAll | ( | void |  | ) |
| virtualinherited

Removes all resources.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to these resources, they will persist until they have been finished with; however to all intents and purposes the resources no longer exist and will get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeUnreferencedResources()

virtual void Ogre::ResourceManager::removeUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| virtualinherited

Remove all resources which are not referenced by any other object.

Remarks
  This method behaves like removeAll, except that it only removes resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, remove or reload that resource will cause dangerous pointer access. Use this function instead of removeAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only removes resources which can be subsequently automatically reloaded.

## ◆ resourceExists() [1/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | const String & | name | ) |
| inlinevirtualinherited

Returns whether the named resource exists in this manager.

## ◆ resourceExists() [2/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | ResourceHandle | handle | ) |
| inlinevirtualinherited

Returns whether a resource with the given handle exists in this manager.

## ◆ setDefaultNumMipmaps()

virtual void Ogre::TextureManager::setDefaultNumMipmaps | ( | size_t | num | ) |
| virtualinherited

Sets the default number of mipmaps to be used for loaded textures, for when textures are loaded automatically (e.g.

by Material class) or when 'load' is called with the default parameters by the application. If set to MIP_UNLIMITED mipmaps will be generated until the lowest possible level, 1x1x1.

Note
  The default value is 0.

## ◆ setMemoryBudget()

virtual void Ogre::ResourceManager::setMemoryBudget | ( | size_t | bytes | ) |
| virtualinherited

Set a limit on the amount of memory this resource handler may use.

Remarks
  If, when asked to load a new resource, the manager believes it will exceed this memory budget, it will temporarily unload a resource to make room for the new one. This unloading is not permanent and the Resource is not destroyed; it simply needs to be reloaded when next used.

## ◆ setPreferredBitDepths()

virtual void Ogre::TextureManager::setPreferredBitDepths | ( | ushort | integerBits,
|  | ushort | floatBits,
|  | bool | reloadTextures = `true`
| ) |  |
| virtualinherited

Sets preferred bit depth for integer and float pixel format.

Parameters

  integerBits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for the pixel.
  floatBits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for a channel of the pixel.
  reloadTextures | If true (the default), will reloading all reloadable textures.

## ◆ setPreferredFloatBitDepth()

virtual void Ogre::TextureManager::setPreferredFloatBitDepth | ( | ushort | bits,
|  | bool | reloadTextures = `true`
| ) |  |
| virtualinherited

Sets preferred bit depth for float pixel format textures.

Parameters

  bits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for a channel of the pixel.
  reloadTextures | If true (the default), will reloading all reloadable textures.

## ◆ setPreferredIntegerBitDepth()

virtual void Ogre::TextureManager::setPreferredIntegerBitDepth | ( | ushort | bits,
|  | bool | reloadTextures = `true`
| ) |  |
| virtualinherited

Sets preferred bit depth for integer pixel format textures.

Parameters

  bits | Number of bits. Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for the pixel.
  reloadTextures | If true (the default), will reloading all reloadable textures.

## ◆ setVerbose()

virtual void Ogre::ResourceManager::setVerbose | ( | bool | v | ) |
| inlinevirtualinherited

Sets whether this manager and its resources habitually produce log output.

## ◆ unload() [1/2]

virtual void Ogre::ResourceManager::unload | ( | const String & | name | ) |
| virtualinherited

Unloads a single resource by name.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unload() [2/2]

virtual void Ogre::ResourceManager::unload | ( | ResourceHandle | handle | ) |
| virtualinherited

Unloads a single resource by handle.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unloadAll() [1/2]

void Ogre::ResourceManager::unloadAll | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  reloadableOnly | If true (the default), only unload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't load them later. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, and Ogre::Resource::LF_INCLUDE_NON_RELOADABLE.

## ◆ unloadAll() [2/2]

virtual void Ogre::ResourceManager::unloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtualinherited

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources.

See also
  Resource::LoadingFlags for additional information.

## ◆ unloadUnreferencedResources()

void Ogre::ResourceManager::unloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Unload all resources which are not referenced by any other object.

Remarks
  This method behaves like unloadAll, except that it only unloads resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of unloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only unloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, and Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE.

## Friends And Related Function Documentation

## ◆ GLES2RenderSystem

friend class GLES2RenderSystem
| friend

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::ResourceManager::OGRE_AUTO_MUTEX
| inherited

The documentation for this class was generated from the following file:

- OgreGLES2TextureManager.h